/**
 * Original work: Copyright (c) 2014 Sergey Skoblikov
 * Modified work: Copyright (c) 2015-2025 Dmitry Ivanov
 *
 * This file is a part of QEverCloud project and is distributed under the terms
 * of MIT license:
 * https://opensource.org/licenses/MIT
 *
 * This file was generated from Evernote Thrift API
 */

#include <qevercloud/types/BootstrapSettings.h>

#include "impl/BootstrapSettingsImpl.h"

namespace qevercloud {

BootstrapSettings::BootstrapSettings() :
    d(new BootstrapSettings::Impl)
{}

BootstrapSettings::BootstrapSettings(const BootstrapSettings & other) :
    d(other.d)
{}

BootstrapSettings::BootstrapSettings(BootstrapSettings && other) noexcept :
    d(std::move(other.d))
{}

BootstrapSettings::~BootstrapSettings() noexcept {}

BootstrapSettings & BootstrapSettings::operator=(const BootstrapSettings & other)
{
    if (this != &other) {
        d = other.d;
    }

    return *this;
}

BootstrapSettings & BootstrapSettings::operator=(BootstrapSettings && other) noexcept
{
    if (this != &other) {
        d = std::move(other.d);
    }

    return *this;
}

const QString & BootstrapSettings::serviceHost() const noexcept
{
    return d->m_serviceHost;
}

void BootstrapSettings::setServiceHost(QString serviceHost)
{
    d->m_serviceHost = std::move(serviceHost);
}

const QString & BootstrapSettings::marketingUrl() const noexcept
{
    return d->m_marketingUrl;
}

void BootstrapSettings::setMarketingUrl(QString marketingUrl)
{
    d->m_marketingUrl = std::move(marketingUrl);
}

const QString & BootstrapSettings::supportUrl() const noexcept
{
    return d->m_supportUrl;
}

void BootstrapSettings::setSupportUrl(QString supportUrl)
{
    d->m_supportUrl = std::move(supportUrl);
}

const QString & BootstrapSettings::accountEmailDomain() const noexcept
{
    return d->m_accountEmailDomain;
}

void BootstrapSettings::setAccountEmailDomain(QString accountEmailDomain)
{
    d->m_accountEmailDomain = std::move(accountEmailDomain);
}

const std::optional<bool> & BootstrapSettings::enableFacebookSharing() const noexcept
{
    return d->m_enableFacebookSharing;
}

std::optional<bool> & BootstrapSettings::mutableEnableFacebookSharing()
{
    return d->m_enableFacebookSharing;
}

void BootstrapSettings::setEnableFacebookSharing(std::optional<bool> enableFacebookSharing)
{
    d->m_enableFacebookSharing = enableFacebookSharing;
}

const std::optional<bool> & BootstrapSettings::enableGiftSubscriptions() const noexcept
{
    return d->m_enableGiftSubscriptions;
}

std::optional<bool> & BootstrapSettings::mutableEnableGiftSubscriptions()
{
    return d->m_enableGiftSubscriptions;
}

void BootstrapSettings::setEnableGiftSubscriptions(std::optional<bool> enableGiftSubscriptions)
{
    d->m_enableGiftSubscriptions = enableGiftSubscriptions;
}

const std::optional<bool> & BootstrapSettings::enableSupportTickets() const noexcept
{
    return d->m_enableSupportTickets;
}

std::optional<bool> & BootstrapSettings::mutableEnableSupportTickets()
{
    return d->m_enableSupportTickets;
}

void BootstrapSettings::setEnableSupportTickets(std::optional<bool> enableSupportTickets)
{
    d->m_enableSupportTickets = enableSupportTickets;
}

const std::optional<bool> & BootstrapSettings::enableSharedNotebooks() const noexcept
{
    return d->m_enableSharedNotebooks;
}

std::optional<bool> & BootstrapSettings::mutableEnableSharedNotebooks()
{
    return d->m_enableSharedNotebooks;
}

void BootstrapSettings::setEnableSharedNotebooks(std::optional<bool> enableSharedNotebooks)
{
    d->m_enableSharedNotebooks = enableSharedNotebooks;
}

const std::optional<bool> & BootstrapSettings::enableSingleNoteSharing() const noexcept
{
    return d->m_enableSingleNoteSharing;
}

std::optional<bool> & BootstrapSettings::mutableEnableSingleNoteSharing()
{
    return d->m_enableSingleNoteSharing;
}

void BootstrapSettings::setEnableSingleNoteSharing(std::optional<bool> enableSingleNoteSharing)
{
    d->m_enableSingleNoteSharing = enableSingleNoteSharing;
}

const std::optional<bool> & BootstrapSettings::enableSponsoredAccounts() const noexcept
{
    return d->m_enableSponsoredAccounts;
}

std::optional<bool> & BootstrapSettings::mutableEnableSponsoredAccounts()
{
    return d->m_enableSponsoredAccounts;
}

void BootstrapSettings::setEnableSponsoredAccounts(std::optional<bool> enableSponsoredAccounts)
{
    d->m_enableSponsoredAccounts = enableSponsoredAccounts;
}

const std::optional<bool> & BootstrapSettings::enableTwitterSharing() const noexcept
{
    return d->m_enableTwitterSharing;
}

std::optional<bool> & BootstrapSettings::mutableEnableTwitterSharing()
{
    return d->m_enableTwitterSharing;
}

void BootstrapSettings::setEnableTwitterSharing(std::optional<bool> enableTwitterSharing)
{
    d->m_enableTwitterSharing = enableTwitterSharing;
}

const std::optional<bool> & BootstrapSettings::enableLinkedInSharing() const noexcept
{
    return d->m_enableLinkedInSharing;
}

std::optional<bool> & BootstrapSettings::mutableEnableLinkedInSharing()
{
    return d->m_enableLinkedInSharing;
}

void BootstrapSettings::setEnableLinkedInSharing(std::optional<bool> enableLinkedInSharing)
{
    d->m_enableLinkedInSharing = enableLinkedInSharing;
}

const std::optional<bool> & BootstrapSettings::enablePublicNotebooks() const noexcept
{
    return d->m_enablePublicNotebooks;
}

std::optional<bool> & BootstrapSettings::mutableEnablePublicNotebooks()
{
    return d->m_enablePublicNotebooks;
}

void BootstrapSettings::setEnablePublicNotebooks(std::optional<bool> enablePublicNotebooks)
{
    d->m_enablePublicNotebooks = enablePublicNotebooks;
}

const std::optional<bool> & BootstrapSettings::enableGoogle() const noexcept
{
    return d->m_enableGoogle;
}

std::optional<bool> & BootstrapSettings::mutableEnableGoogle()
{
    return d->m_enableGoogle;
}

void BootstrapSettings::setEnableGoogle(std::optional<bool> enableGoogle)
{
    d->m_enableGoogle = enableGoogle;
}

void BootstrapSettings::print(QTextStream & strm) const
{
    d->print(strm);
}

QTextStream & operator<<(QTextStream & strm, const BootstrapSettings & bootstrapSettings)
{
    strm << static_cast<const Printable&>(bootstrapSettings);
    return strm;
}

QDebug & operator<<(QDebug & dbg, const BootstrapSettings & bootstrapSettings)
{
    dbg << static_cast<const Printable&>(bootstrapSettings);
    return dbg;
}

std::ostream & operator<<(std::ostream & strm, const BootstrapSettings & bootstrapSettings)
{
    strm << static_cast<const Printable&>(bootstrapSettings);
    return strm;
}

bool operator==(const BootstrapSettings & lhs, const BootstrapSettings & rhs) noexcept
{
    if (&lhs == &rhs) {
        return true;
    }

    return
        lhs.serviceHost() == rhs.serviceHost() &&
        lhs.marketingUrl() == rhs.marketingUrl() &&
        lhs.supportUrl() == rhs.supportUrl() &&
        lhs.accountEmailDomain() == rhs.accountEmailDomain() &&
        lhs.enableFacebookSharing() == rhs.enableFacebookSharing() &&
        lhs.enableGiftSubscriptions() == rhs.enableGiftSubscriptions() &&
        lhs.enableSupportTickets() == rhs.enableSupportTickets() &&
        lhs.enableSharedNotebooks() == rhs.enableSharedNotebooks() &&
        lhs.enableSingleNoteSharing() == rhs.enableSingleNoteSharing() &&
        lhs.enableSponsoredAccounts() == rhs.enableSponsoredAccounts() &&
        lhs.enableTwitterSharing() == rhs.enableTwitterSharing() &&
        lhs.enableLinkedInSharing() == rhs.enableLinkedInSharing() &&
        lhs.enablePublicNotebooks() == rhs.enablePublicNotebooks() &&
        lhs.enableGoogle() == rhs.enableGoogle();
}

bool operator!=(const BootstrapSettings & lhs, const BootstrapSettings & rhs) noexcept
{
    return !operator==(lhs, rhs);
}

} // namespace qevercloud
